# Menus and GUI for JointSU Class 1.0   2009.Fev.16   by   Marcio de A. Braga
#
require 'JointSU.rb'
######################################
class AnimateJointSU
def initialize(kine)
	@kine=kine
end
def nextFrame(view)
	while Sketchup.active_model.close_active; end # set path at Model level
	for n in @kine
		n[0].transform!(n[1])
	end
	view.show_frame
	true
end
end # Class
######################################
class ToolHandleJointSU # << entra C2 sai C2 >>
def initialize(junta)
	@jointSU=junta
	Sketchup.active_model.select_tool(nil) if not @jointSU.isConnected?
	@jointSU.setTransformations(false)
	@turbo=false
	t="Use Up/Down/Right/Left/Home to handle JointSU"
	Sketchup.set_status_text(t, SB_PROMPT)
end
def deactivate(view)
	end
def activate # << entra J1 sai C2 >>
	end
def onKeyDown(key, repeat, flags, view) # <<entra e sai em C2 >>
	#------------------------------------------------------[PREREQ] estar posicionado em C2 (fixo)
	case (key)
		when 27 # tecla Escape
			Sketchup.active_model.selection.clear
			Sketchup.active_model.select_tool(nil)
		when VK_RIGHT # seta Right
			@jointSU.execTransformation("delta+")
		when VK_LEFT # seta Left
			@jointSU.execTransformation("delta-")
		when VK_UP # seta Up
			@jointSU.execTransformation("alpha+")
		when VK_DOWN # seta Down
			@jointSU.execTransformation("alpha-")
		when 78
			#r=@jointSU.getParentComponents
			#j2=r[0]
			#@c1=r[2]
			#t_J2C2=j2.transformation
			#@t3=Geom::Transformation.rotation(t_J2C2.origin,t_J2C2.xaxis,PI/180.0) # torcao positiva
			#for kk in 1..10
			#	@c1.transform!(@t3)
			#	Sketchup.active_model.active_view.invalidate
			#	Sketchup.active_model.active_view.draw				
			#	Sketchup.active_model.active_view.show_frame
			#	sleep(0.3)				
			#end
			#return
		when VK_SHIFT
			if @turbo
				@turbo=false
			else
				@turbo=true
			end
			@jointSU.setTransformations(@turbo)
		when VK_HOME
			@jointSU.execTransformation("flip")
		else
			#p key 
	end	
	r=@jointSU.getJ1parms_fromModel
	@jointSU.setJ1parms_toDictionary(r)
	t="#{sprintf("%.3f",r[0].to_m)}"
	t=t+" #{sprintf("%.2f",r[1].radians)}"
	t=t+" flip:#{r[2]}"
	t=t+" turbo:#{@turbo}"
	Sketchup.set_status_text(t, SB_PROMPT)
end

end
######################################
class ToolHandleCompoSU
def initialize(compo)
	@compoSU=compo
	@msg1="Drag Mouse horizontaly. Keys 1/2/3/4/5/6 to lock on x/y/z/alpha/beta/torsion"
	Sketchup.set_status_text(@msg1, SB_PROMPT)
	@acao=1
	@xant=0.0
	@var1=1.0.mm
	@var2=PI/180.0
	@msgAcao=["Lock on ","X","Y","Z","Horiz Rotation (xy)","Vert Rotation (z)","Torsion (x)"]
end

def deactivate(view)
	end

def activate
	end


def panel
	r1=@compoSU.getOriginFromCompo
	a1="#{sprintf("%.4f",r1.x.to_m)}".to_f
	a2="#{sprintf("%.4f",r1.y.to_m)}".to_f
	a3="#{sprintf("%.4f",r1.z.to_m)}".to_f
	
	r2=@compoSU.getPolarFromCompo			
	a4="#{sprintf("%.2f",r2[0].radians)}".to_f
	a5="#{sprintf("%.2f",r2[1].radians)}".to_f
	a6="#{sprintf("%.2f",r2[2].radians)}".to_f
	
	values=[a1,a2,a3,a4,a5,a6]
	prompts = ["x(m)","y(m)","z(m)","alfa(-180,180)","beta(-90,90)","torsion(-180,180)"]
	r = inputbox(prompts, values, "Polar")
	return if r == false
	pOrigin=Geom::Point3d.new(r[0].m,r[1].m,r[2].m)
	if not @compoSU.setCompoOnPolar(pOrigin,r[3].degrees,r[4].degrees,r[5].degrees)
		p "PROBLEMA"
	end
end

def onKeyDown(key, repeat, flags, view)
	case (key)
	when 27 # tecla Escape
		Sketchup.active_model.selection.clear
		Sketchup.active_model.select_tool nil
	when ?1
		@acao=1
	when ?2
		@acao=2
	when ?3
		@acao=3
	when ?4
		@acao=4
	when ?5
		@acao=5
	when ?6
		@acao=6
	when ?7
		panel
	when 39 # seta UP
		value=exec(1)
	when 37 # seta DOWN
		value=exec(-1)
	else
		#p key 
	end
	mama2
end

def mama2
	if @acao==1
		value=@compoSU.getOriginFromCompo.x.to_m
	elsif @acao==2
		value=@compoSU.getOriginFromCompo.y.to_m	
	elsif @acao==3
		value=@compoSU.getOriginFromCompo.z.to_m
	elsif @acao==4
		value=@compoSU.getAlphaFromCompo.radians
	elsif @acao==5
		value=@compoSU.getBetaFromCompo.radians
	elsif	@acao==6
		value=@compoSU.getTorsionFromCompo.radians	
	end
	Sketchup.set_status_text(@msgAcao[0]+@msgAcao[@acao], SB_PROMPT)
	Sketchup.set_status_text("#{sprintf("%.3f",value)}", SB_VCB_VALUE)
end

def onMouseMove(flags, xt, yt, view)
	# 0=none / 1=Left / 2=Right / 4=Shift / 8=Ctrl / 16=??? / 32=Alt  / Alt Gr = alt + ctrl
	if flags==1 then # Move with only LButton down
		if xt != @xant then # Horiz plane rotation
			if xt>@xant then multiplier=1.0 else multiplier=-1.0 end
			value=exec(multiplier)
			Sketchup.set_status_text("#{sprintf("%.3f",value)}", SB_VCB_VALUE)			
			@xant=xt
		end
	end
	end

def exec(multiplier)
	value=0
	if @acao==1
		value=@compoSU.addXonCompo(multiplier*@var1).to_m
	elsif @acao==2
		value=@compoSU.addYonCompo(multiplier*@var1).to_m
	elsif @acao==3
		value=@compoSU.addZonCompo(multiplier*@var1).to_m
	elsif @acao==4
		value=@compoSU.addAlphaOnCompo(multiplier*@var2).radians
	elsif @acao==5
		value=@compoSU.addBetaOnCompo(multiplier*@var2).radians
	elsif @acao==6
		value=@compoSU.addTorsionOnCompo(multiplier*@var2).radians
	end
	#Sketchup.set_status_text("#{sprintf("%.3f",value.to_m)}", SB_VCB_VALUE)
	value
end
	
end # Class Test2
######################################
class ToolConnectJointSU # << entra C1 sai C2 >> # Call ToolHandleJointSU at the end
def initialize(junta) # << entra C1 sai C1 >>
	@jointSU=junta
	t="Set connection: Sel JointSU (joints will be aligned)"
	Sketchup.set_status_text(t, SB_PROMPT)
end
def activate # << entra C1 sai C1 >>
end
def deactivate(view)
end
def onKeyDown(key, repeat, flags, view)
	case (key)
	when 27 # tecla Escape
		Sketchup.active_model.selection.clear
		Sketchup.active_model.select_tool(nil)
	end
end	
def onLButtonDown(flag, x, y, view) # << entra C1 sai C2 >>
	# precisa entrar em C1 para travar a selecao no nivel da J2
	# 0=none / 1=Left / 2=Right / 4=Shift / 8=Ctrl / 16=??? / 32=Alt  / Alt Gr = alt + ctrl
	ph=Sketchup.active_model.active_view.pick_helper
	if ph.do_pick(x,y) != 0 then # pegou alguma coisa
		pick=ph.best_picked
		r=@jointSU.setJ2_fromPick(pick) # << entra C1 sai C2 se OK ou sai C1 se KO>>
		if r==1
			@jointSU.alignJ1([0.0,0.0,false]) # << entra C2 sai C2 >> posiciona J1 sobre J2
			@jointSU.setJ1parms_toDictionary([0.0,0.0,false])
			Sketchup.active_model.select_tool(nil)
			# transfer the jointSU instance to ToolHandle for user adjustments
			Sketchup.active_model.select_tool(ToolHandleJointSU.new(@jointSU))
		elsif r==3
			t="<< JointSU without Name >>\n\n"
			t=t+"It is necessary to name the JointSU (parent and child)\n"
			t=t+"to make possible to handle them.\n\n"
			t=t+"The name of each JointSU immediatelly below a Compo\n"
			t=t+"must be unique (but not being checked here)\n\n"
			t=t+"To set this name you can use:\n"
			t=t+"SketchUp ENTITY INFO (on contextual menu)\n"
			r=UI.messagebox(t, MB_OK)
		end
	end
	end

end # Class ToolSetJointSU
######################################
class CameraOOT
def initialize(target)
	@vetorZ=Geom::Vector3d.new(0.0, 0.0, 1.0)
	@xant=0.0
	@yant=0.0
	@camera = Sketchup.active_model.active_view.camera
	@target=target
	@center=@target.clone
	@vetorH=Geom::Vector3d.new(@camera.eye.x-@target.x,@camera.eye.y-@target.y,0.0)
	angV=Math.asin((@camera.eye.z-@target.z)/@camera.eye.distance(@target))+0.5*Math::PI
	vetorN=Geom::Vector3d.new(@vetorH.y,-1.0*@vetorH.x,0)
	@vetorT=@vetorH.transform(Geom::Transformation.rotation(@target, vetorN, angV))
	@camera.set(@camera.eye,@target,@vetorT)
	@msg1="CameraOnTarget: Rotate(LButton) Zoom(+Shift) Pan(+Ctrl) ReCenter(Double-click)"	
	Sketchup.set_status_text(@msg1, SB_PROMPT)
end

def resume(view)
	Sketchup.set_status_text(@msg1, SB_PROMPT)
end

def deactivate(view)
	Sketchup.set_status_text("Exit CameraOnTarget", SB_PROMPT)
	Sketchup.active_model.select_tool(nil)
	end

def onKeyDown(key, repeat, flags, view)
	case (key)
	when 27 # tecla Escape
		Sketchup.active_model.selection.clear
		Sketchup.active_model.select_tool(nil)
	end
end	

def onLButtonDoubleClick(flags, x, y, view)
	@center=@target.clone
	@camera.set(@camera.eye,@target,@vetorT)
end

def onLButtonDown(flags, x, y, view)
	#Sketchup.set_status_text(@msg1, SB_PROMPT)
	end

def onMouseMove(flags, x, y, view)
	# 0=none / 1=Left / 2=Right / 4=Shift / 8=Ctrl / 16=??? / 32=Alt  / Alt Gr = alt + ctrl
	if flags==1 # only LButton down # Rotate
		e1=@camera.eye
		if x != @xant # Horiz plane rotation
			if x>@xant then kk=-0.005 else kk=0.005 end
			bb=(x-@xant).abs
			bb=5.0 if bb>5.0
			deltaH=kk*bb
			@xant=x
			transf1 = Geom::Transformation.rotation(@target, @vetorZ, deltaH)
			e1.transform!(transf1) # Move Eye com Rotacao em torno de Z e centro em T
			@vetorH.transform!(transf1)
			@vetorT.transform!(transf1)
			@center.transform!(transf1) # Move C com Rotacao em torno de Z e centro em T
		end
		if y != @yant # Vert plane rotation
			if y>@yant then kk=0.005 else kk=-0.005 end
			bb=(y-@yant).abs
			bb=5.0 if bb>5.0
			deltaV=kk*bb
			@yant=y
			vetorN=Geom::Vector3d.new(@vetorH.y,-1.0*@vetorH.x,0)
			transf2 = Geom::Transformation.rotation(@target, vetorN, deltaV)
			e1.transform!(transf2) # transf Vert do Eye
			@vetorT.transform!(transf2)
			@center.transform!(transf2) # Move C com Rotacao em torno da Normal ao Plano Vertical e centro em T
		end
		@camera.set(e1,@center,@vetorT)
	elsif	flags==5 then # Shift + LButton down # Zoom
		if y != @yant then
			if y>@yant then kk=-1.0 else kk=1.0 end
			bb=(y-@yant).abs
			bb=5.0 if bb>5.0
			pp=kk*bb/100.0
			e1=Geom::Point3d.linear_combination((1.0-pp),@camera.eye,pp, @target)
			@center=Geom::Point3d.linear_combination((1.0-pp),@camera.target, pp, @target)
			@yant=y
			@camera.set(e1,@center,@camera.up)
		end
	elsif flags==9 then # Ctrl + LButton down # Pan
		if y != @yant then
			e1=@camera.eye
			rx=@center.x-e1.x
			ry=@center.y-e1.y
			if y>@yant then kk=0.01 else kk=-0.01 end
			e1.x=e1.x+kk*rx
			e1.y=e1.y+kk*ry
			@center.x=@center.x+kk*rx
			@center.y=@center.y+kk*ry
			@yant=y
			@camera.set(e1,@center,@vetorT)
		end
		if x != @xant then
			e1=@camera.eye
			rx=@center.x-e1.x
			ry=@center.y-e1.y
			if x>@xant then kk=0.01 else kk=-0.01 end
			e1.x=e1.x-kk*ry
			e1.y=e1.y+kk*rx
			@center.x=@center.x-kk*ry
			@center.y=@center.y+kk*rx
			@xant=x
			@camera.set(e1,@center,@vetorT)
		end
	end
	end # onMouseMove
	
end # class Test1
######################################
module MenuStuff
def self.infoSU
	joint=JointSU.new
	r=joint.status
	# 0 = J1 connected with J2 and aligned
	# 1 = J1 connected with J2 but not aligned
	# 2 = J1 not connected with J2
	# 3 = J1 has no name
	# 4 = J1 at Model level
	# 5 = J2 has no name
	# 99 = J1 is not a JointSU
	p r
	if r==0 # Joint connected and aligned
		t="JointSU connected and aligned\n\n"
		r1=joint.getJ1parms_fromDictionary
		r3=joint.getParentComponents
		if r1 !=nil
			t=t+"  Tanslation: #{r1[0]}\n"
			t=t+"  Rotation: #{sprintf("%.2f",r1[1].radians)} degrees\n"
			t=t+"  Flip: #{r1[2]}\n\n"
			t=t+"Parent JointSU: #{r3[0].name}\n"		
			t=t+"  on: #{r3[1].name} <#{r3[1].definition.name}>"
		else
			t="ups ... not expected to be here"
		end
	elsif r==1 # Joint connected but not aligned
		t="JointSU connected but NOT aligned\n"
		t=t+"Dictionary // Model\n\n"			
		r1=joint.getJ1parms_fromDictionary
		r2=joint.getJ1parms_fromModel
		r3=joint.getParentComponents
		if r1 !=nil and r2 !=nil
			t=t+"  Tanslation: #{r1[0]} // #{r2[0]}\n"
			t=t+"  Rotation: #{sprintf("%.2f",r1[1].radians)} // #{sprintf("%.2f",r2[1].radians)} degrees\n"
			t=t+"  Flip: #{r1[2]} // #{r2[2]}\n\n"
			t=t+"Parent JointSU: #{r3[0].name}\n"		
			t=t+"  on: #{r3[1].name} <#{r3[1].definition.name}>"
		else
			t="ups ... not expected to be here"
		end		
	elsif r==2 # Joint not connected  # portanto ainda esta em C1
		t="JointSU NOT Connected (so, no parms)"
	elsif r==3 # Joint has no name
		t="<< JointSU without Name >>\n\n"
		t=t+"It is necessary to name the JointSU (parent and child)\n"
		t=t+"to make possible to handle them.\n\n"
		t=t+"The name of each JointSU immediatelly below a Compo\n"
		t=t+"must be unique (but not being checked here)\n\n"
		t=t+"To set this name you can use:\n"
		t=t+"SketchUp ENTITY INFO (on contextual menu)\n"
	elsif r==4 # Joint at Model level
		t="JointSU at model level"
	else
		t="This is NOT a JointSU"
	end
	UI.messagebox(t, MB_MULTILINE)
end

def self.animateSU
	joint=JointSU.new
	r=joint.status
	# 0 = J1 connected with J2 and aligned
	# 1 = J1 connected with J2 but not aligned
	# 2 = J1 not connected with J2
	# 3 = J1 has no name
	# 4 = J1 at Model level
	# 5 = J2 has no name
	# 99 = J1 is not a JointSU
	if r<=1
		m=joint.getJ1parms_fromDictionary
		if m[3]==nil and m[4]==nil
			joint.setJ1parmsAnime_toDictionary([false,0])
			m=joint.getJ1parms_fromDictionary
		end
		values=[m[3],m[4].radians]
		prompts = ["Active (true/false)","Step"]
		mbox = inputbox(prompts, values, "xxx")
		if mbox != false
			if mbox[0]=="true"
				mbox[0]=true
			else
				mbox[0]=false
			end
			mbox[1]=mbox[1].degrees
			if not joint.setJ1parmsAnime_toDictionary(mbox)
				t="Unexpected error. No dictionary on joint"
				r=UI.messagebox(t, MB_OK)					
			end	
		end
	end
end
def self.zeroSU # also fix problem with Axes
	compo=CompoSU.new
	return if not compo.isValid?
	compo.zeroCompo
end

def self.createJointSU
	r = UI.inputbox(["Size"], [1.feet], "Joint Size")
	M1.createGeoForJointSU(r[0]) if r != false 
end
	
def self.disconnectSU
	JointSU.new.deleteConnection
	t="JointSU disconnected"
	Sketchup.set_status_text(t, SB_PROMPT)
end
def self.panelCompoSU
	compo=CompoSU.new
	if compo.isValid?
		while true
			return if panelOnce(compo)
		end
	end
end

def self.panelOnce(compo)
	r1=compo.getOriginFromCompo
	a1="#{sprintf("%.2f",r1.x.to_mm)}".to_f
	a2="#{sprintf("%.2f",r1.y.to_mm)}".to_f
	a3="#{sprintf("%.2f",r1.z.to_mm)}".to_f
	
	r2=compo.getPolarFromCompo			
	a4="#{sprintf("%.2f",r2[0].radians)}".to_f
	a5="#{sprintf("%.2f",r2[1].radians)}".to_f
	a6="#{sprintf("%.2f",r2[2].radians)}".to_f
	
	values=[a1,a2,a3,a4,a5,a6]
	prompts = ["x(mm)","y(mm)","z(mm)","alfa(-180,180)","beta(-90,90)","torsion(-180,180)"]
	r = inputbox(prompts, values, "Polar related to Parent")
	return true if r == false
	pOrigin=Geom::Point3d.new(r[0].mm,r[1].mm,r[2].mm)
	if not compo.setCompoOnPolar(pOrigin,r[3].degrees,r[4].degrees,r[5].degrees)
		p "PROBLEMA"
		return true
	end
	false
end

def self.panelJointSU
	joint=JointSU.new
	if joint.isValid?
		if joint.isConnected?
			if not joint.isAligned?
				t="This JointSU is NOT aligned as in Dictionary\n\n"
				t=t+"OK = Align as in Dictionary\n"
				t=t+"CANCEL = Exit without any change"
				mbox=UI.messagebox(t, MB_OKCANCEL) # 6=Yes  7=No  2=Cancel
				if r==2 # quer sair sem fazer nada
					return
				end
				joint.alignJ1(joint.getJ1parms_fromDictionary)
			end
			while true
				m=joint.getJ1parms_fromDictionary
				a1="#{sprintf("%.4f",m[0].to_mm)}".to_f
				a2="#{sprintf("%.2f",m[1].radians)}".to_f	
				values=[a1,a2,m[2]]
				prompts = ["Translation(mm)","Rotation(-180,180)","Flip(true,false)"]
				mbox = inputbox(prompts, values, "JointSU parms Panel")
				return if mbox == false
				mbox[0]=mbox[0].mm
				mbox[1]=mbox[1].degrees
				if mbox[2]=="true"
					mbox[2]=true
				else
					mbox[2]=false
				end
				joint.alignJ1(mbox)
				joint.setJ1parms_toDictionary(mbox)
			end
		else
			t="JointSU NOT Connected (so, no parms)"
		end
	else
		t="This is NOT a JointSU"
	end
	UI.messagebox(t, MB_MULTILINE)
end

def self.toolHandleSU
	compo=CompoSU.new
	if compo.isValid?
		Sketchup.active_model.select_tool(ToolHandleCompoSU.new(compo))
	else
		t="This is NOT a Component"
		r=UI.messagebox(t, MB_OK)
	end
end

def self.toolSetSU
	joint=JointSU.new # << entra J1 sai C1 ou C2 >>
	r=joint.status
	if r==0 # Joint connected and aligned
		Sketchup.active_model.select_tool(ToolHandleJointSU.new(joint)) # << entra C2 sai C2 >>
	elsif r==1 # Joint connected but not aligned
		t="This JointSU is NOT aligned as in Dictionary\n\n"
		t=t+"YES = Align as in Dictionary + Handle mode\n"
		t=t+"NO = Remove connection\n" # can not entry Connection mode because do not have OpenComponent
		t=t+"CANCEL = Exit without any change"
		mbox=UI.messagebox(t, MB_YESNOCANCEL) # 6=Yes  7=No  2=Cancel
		if mbox==6 # YES # alinha
			joint.alignJ1(joint.getJ1parms_fromDictionary)
			Sketchup.active_model.select_tool(ToolHandleJointSU.new(joint)) # << entra C2 sai C2 >>
		elsif mbox==7 then # NO # desconecte # can not entry Connection mode because do not have OpenComponent
			joint.deleteConnection # nao consigo entrar em Connect porque esta em C2
		end
	elsif r==2 # Joint not connected  # portanto ainda esta em C1
		Sketchup.active_model.select_tool(ToolConnectJointSU.new(joint)) # << entra C1 sai C2 >>
	elsif r==3 # Joint has no name
		t="<< JointSU without Name >>\n\n"
		t=t+"It is necessary to name the JointSU (parent and child)\n"
		t=t+"to make possible to handle them.\n\n"
		t=t+"The name of each JointSU immediatelly below a Compo\n"
		t=t+"must be unique (but not being checked here)\n\n"
		t=t+"To set this name you can use:\n"
		t=t+"SketchUp ENTITY INFO (on contextual menu)\n"
		r=UI.messagebox(t, MB_OK)
	elsif r==4 # Joint at Model level
		t="JointSU at model level"
		r=UI.messagebox(t, MB_OK)
	else
		t="This is NOT a JointSU"
		r=UI.messagebox(t, MB_OK)
	end
end

def self.checkThisDictSU
	joint=JointSU.new.checkDictionary
end
def self.toolCameraSU
	pick=Sketchup.active_model.selection[0]
	if pick.typename != "ComponentInstance"
		t="This is NOT a Component"
		r=UI.messagebox(t, MB_OK)
	else
		target=pick.transformation.origin
		Sketchup.active_model.select_tool(CameraOOT.new(target))
	end
end
def self.cleanDict
	selectSU(0)
	M1.cleanDictionaries
end
def self.assembleSU
	M1.assemble
end
def self.explodeSU
	M1.explode(10.0)
end
def self.selectSU(condition)
	# 0 = hide all JointSU
	# 1 = unhide all JointSU
	# 2 = select all JointSU
	Sketchup.active_model.selection.clear if condition==2
	Sketchup.active_model.entities.each do |filho|
		if filho.typename=="ComponentInstance"
			filhos(filho,condition)
		end
	end
end

def self.filhos(compo,condition)
	if condition==0
		compo.hidden=true if compo.definition.name =="JointSU"
	elsif condition==1
		compo.hidden=false if compo.definition.name =="JointSU"
	elsif condition==2
		Sketchup.active_model.selection.add(compo) if compo.definition.name=="JointSU"
	end
	compo.definition.entities.each do |filho|
		if filho.typename=="ComponentInstance"
			filhos(filho,condition)
		end
	end
end

def self.execAnimationSU(status)
	# if status is true, go ahead. If status is false, stop animation destroying the SketchUP animation class.
	if status
		Sketchup.active_model.active_view.animation = AnimateJointSU.new(M1.animation)
	else
		Sketchup.active_model.active_view.animation = nil
	end
end


def self.miniHelpSU
	t="soon ..."
	r=UI.messagebox(t, MB_OK)
end
def self.checkAxes
	r=M1.checkProbOnAxes
	if r.size==0
		t="No problem with Axes"
	else
		t="Problem with Axes (values in degrees)\n"
		t=t+"Use contextual menu Position/Zero to fix\n\n" 
		for n in r
			t=t+n[0].name+" <"+n[0].definition.name+">"
			t=t+"  #{sprintf("%.3f",n[1].radians)}"
			t=t+"  #{sprintf("%.3f",n[2].radians)}"
			t=t+"  #{sprintf("%.3f",n[3].radians)}\n"
		end
	end
	UI.messagebox(t, MB_MULTILINE)	
end
def self.renameSU
	t="soon ..."
	r=UI.messagebox(t, MB_OK)
end
def self.f1
	compo=CompoSU.new
	r=compo.getAxesError
	if r[0]
		t="Problem"
	else
		t="No Problem"
	end
	r=UI.messagebox(t, MB_OK)
end
def self.start	# OBS: mudar codigo nessa funcao significa sair/entrar no SketchUP
	# para permitir a chamada que vem de fora
	
	# MENU CONTEXTUAL #########################
	UI.add_context_menu_handler do |hCMenu|
		hCMenu.add_separator
		hCMenu1=hCMenu.add_submenu("JointSU")
		#
		hCMenu2=hCMenu1.add_submenu("Joint")
		hCMenu2.add_item("Set") { toolSetSU }
		hCMenu2.add_item("Info") { infoSU }
		hCMenu2.add_item("Disconnect") { disconnectSU }
		hCMenu2.add_item("Panel") { panelJointSU }
		hCMenu2.add_item("Rename") { renameSU }
		hCMenu2.add_item("Set anime") { animateSU }
		hCMenu2.add_item("Check dict") { checkThisDictSU }		
		#
		hCMenu3=hCMenu1.add_submenu("Position")
		hCMenu3.add_item("Mouse") { toolHandleSU }		
		hCMenu3.add_item("Panel") { panelCompoSU }
		hCMenu3.add_item("Zero") { zeroSU }
		#
		hCMenu1.add_item("CameraOnT") {toolCameraSU }		
		hCMenu1.add_item("Check Axes") { f1 }
		hCMenu1.add_item("f2") { f2 }		
	end
	
	# MENU DO FRAME (FILE. EDIT, VIEW ....) #############
	menu0=UI.menu("Plugins")
	menu1=menu0.add_submenu("JointSU")
	menu1.add_item("Create JointSU compo") { createJointSU }
	menu3=menu1.add_submenu("Hide/Unhide")
	menu3.add_item("Hide all JointSU") { selectSU(0) }
	menu3.add_item("Unhide all JointSU") { selectSU(1) }
	menu3.add_item("Select all JointSU") { selectSU(2) }
	menu1.add_item("Clean dictionaries") { cleanDict }
	menu1.add_item("Assemble") { assembleSU }
	menu1.add_item("Explode") { explodeSU }
	menu2=menu1.add_submenu("Animate")
	menu2.add_item("Start") { execAnimationSU(true) }
	menu2.add_item("Stop") { execAnimationSU(false) }
	menu1.add_item("Mini help") { miniHelpSU }	
	menu1.add_item("Check Axes") { checkAxes }
end

end # END MODULE
######################################
MenuStuff.start if not file_loaded?("JointSU_GUI.rb")
file_loaded("JointSU_GUI.rb")